package net.citrusleaf.LoadTest;

import java.util.Random;
import java.util.Vector;
import net.citrusleaf.CitrusleafClient.*;

public class InsertTask implements Runnable {

	int startKey;
	int nKeys;
	int keySize;
	int nBins;	
	int timeout;
	CounterStore counters;
	CLKeyValueStore kvs;
	DBObjectSpec[] spec;
	
	public InsertTask(CLKeyValueStore kvs, int startKey, int nKeys, int keySize, int nBins, int timeout, DBObjectSpec[] spec, CounterStore counters) {
		this.kvs = kvs;
		this.startKey = startKey;
		this.nKeys    = nKeys;
		this.keySize  = keySize;
		this.nBins    = nBins;
		this.counters = counters;
		this.spec      = spec;
		this.timeout  = timeout;
	}

	public void run() {
		try {
			Random r = new Random();
			String key;
			Vector<ClBin> value;
			int i = this.counters.wcounter.getAndIncrement();
			while (i < this.nKeys) {
				key	  = Utils.genKey(this.startKey+i, this.keySize);
				value = Utils.genValueObj(r, this.nBins, this.spec, 0);
				this.kvs.SetValue(key, value, this.timeout);
				i = this.counters.wcounter.getAndIncrement();
			}
		}
		catch (Exception ex) {
			System.out.println("Insert error: " + ex.getMessage());
			ex.printStackTrace();
		}
	}

}
