/*
 *  Citrusleaf Aerospike Java Library
 *
 *  Copyright 2009-2010 by Citrusleaf, Inc.  All rights reserved.
 *  
 *  Availability of this source code to partners and customers includes
 *  redistribution rights covered by individual contract. Please check
 *  your contract for exact rights and responsibilities.
 */

package net.citrusleaf;

import java.io.IOException;
import java.net.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;
import java.util.concurrent.*;
import java.util.concurrent.atomic.AtomicInteger;
import java.text.ParseException;


// Node representing a single CitrusLeaf node.
public class CLNodeAddress
{
		public String hostname;
		public int port;
		public String fullName;
		
		public CLNodeAddress (String hostname, int port)
		{
			this.hostname = hostname;
			this.port = port;
			fullName = hostname + ":" + port;
		}
		public CLNodeAddress (String fullName) throws ParseException {
			String[] parts = fullName.split(":");
			if (parts.length != 2) 				throw new ParseException("node address must be host colon port",0);
			this.hostname = parts[0];
			this.port = Integer.parseInt(parts[1]);
			if (this.port > 65535) throw new ParseException("port not in range",0);
			fullName = fullName;
		}
		
		@Override
		public String toString() { 			return( fullName ); }
		
		@Override
		// Know how to do equivilence to strings and other nodeAddresses
		public boolean equals(Object o)  {
			try {
				CLNodeAddress o_na = (CLNodeAddress) o;
				return( this.fullName.equals( o_na.fullName ) );
			}
			catch (Exception e) {
				try {
					String o_str = (String) o;
					return( this.fullName.equals( o_str ) );
				}
				catch (Exception e2) {
					;
				}
			}
			throw new ClassCastException("can't cast "+o.toString()+" to a CLNodeAdress for compare"); 
		}
		
		public boolean isEqual(String hostname, int port) {
			if (this.port != port) return(false);
			if (this.hostname.equals(hostname)==false) return(false);
			return(true);
		}
		
		@Override
		public int hashCode() 	{	return( fullName.hashCode() ); }
			
}
	

