package net.citrusleaf;



public class CLScanNodeThread extends Thread {
	private CitrusleafClient client;
	private String namespace;
	private String setname;
	private String nodename;
	private boolean nobindata;
	private int scan_pct;
	private CitrusleafClient.ScanCallback callback;
	private CitrusleafClient.ClOptions cl_options;
	private CitrusleafClient.ClScanningOptions scan_options;
	private Object cb_udata;
	private CitrusleafClient.ClResultCode result;

	public CLScanNodeThread(CitrusleafClient client, 
			String node_name,
			String namespace,
			String setname,
			boolean nobindata,
			int scan_pct,
			CitrusleafClient.ScanCallback callback,
			CitrusleafClient.ClOptions cl_options,
			CitrusleafClient.ClScanningOptions scan_options,
			Object cb_udata) {
		super();
		this.client = client;
		this.namespace = namespace;
		this.setname = setname;
		this.nodename = node_name;
		this.nobindata = nobindata;
		this.scan_pct = scan_pct;
		this.callback = callback;
		this.cl_options = cl_options;
		this.scan_options = scan_options;
		this.cb_udata = cb_udata;
		this.result = CitrusleafClient.ClResultCode.NOT_SET;			
	}
	
	public void run()
	{
		this.result = client.scanNode(nodename, namespace, setname, nobindata,scan_pct,cl_options, scan_options, callback, cb_udata);
	}
	
	public String getNodeName()
	{
		return nodename;
	}
	public CitrusleafClient.ClResultCode getResult()
	{
		return result;
	}
}
