package net.citrusleaf.examples;

import java.text.SimpleDateFormat;
import java.util.Calendar;

import net.citrusleaf.CitrusleafClient;
import net.citrusleaf.CitrusleafClient.ClLogLevel;

public class Console implements CitrusleafClient.LogCallback {

	private static final SimpleDateFormat Formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss z");

	public Console() {
		CitrusleafClient.setLogging(ClLogLevel.INFO, this);
	}

	public void info(String format, Object... args) {
		log(CitrusleafClient.ClLogLevel.INFO, format, args);
	}

	public void info(String message) {
		log(CitrusleafClient.ClLogLevel.INFO, message);
	}

	public void warn(String format, Object... args) {
		log(CitrusleafClient.ClLogLevel.WARN, format, args);
	}

	public void warn(String message) {
		log(CitrusleafClient.ClLogLevel.WARN, message);
	}

	public void error(String format, Object... args) {
		log(CitrusleafClient.ClLogLevel.ERROR, format, args);
	}

	public void error(String message) {
		log(CitrusleafClient.ClLogLevel.ERROR, message);
	}

	public void log(CitrusleafClient.ClLogLevel level, String format, Object... args) {
		log(level, String.format(format, args));
	}

	public void log(CitrusleafClient.ClLogLevel level, String message) {
		log(Formatter.format(Calendar.getInstance().getTime()) + ' ' + level + ' ' + message);
	}

	public void log(String format, Object... args) {
		log(String.format(format, args));
	}

	public void log(String message) {
		System.out.println(message);
	}

	@Override
	public void logCallback(ClLogLevel level, String message) {
		log(message);
	}
}
