package net.citrusleaf.examples;

import net.citrusleaf.CitrusleafClient;

public abstract class Example {

	protected static final int DEFAULT_TIMEOUT_MS = 1000;

	protected Console console;

	public Example(Console console) {
		this.console = console;
	}

	public void run(CitrusleafClient cs, Parameters params) throws Exception {
		console.info(this.getClass().getSimpleName() + " Begin");
		runExample(cs, params);
		console.info(this.getClass().getSimpleName() + " End");
	}

	public abstract void runExample(CitrusleafClient cs, Parameters params) throws Exception;
}
